      IMPLICIT NONE

#include"../SLHAplus.fh"

#define       MT(i,j)  (i-1)*dim+j
#define      sMT(i,j)  (i-1)*dim-(i*(i-1))/2 +j
            


#define MAXDIM 4

      INTEGER i,j,k,dim
      REAL*8 A(MAXDIM*MAXDIM),sr
      COMPLEX*16 Ac(MAXDIM*MAXDIM),sc
      INTEGER id
      
      write(*,*) " Testing dim=2 case"
      dim=2  
      id=initDiagonal()  

      write(*,*)"Diagonalizing of real symmetry matrix:"
      write(*,*)"===================================================="
    
      A(MT(1,1))=0.1
      A(MT(1,2))=3
      A(MT(2,1))=A(MT(1,2))
      A(MT(2,2))=2
      
      DO i=1,dim
      DO j=1,dim
        write(*,fmt='(3x, 1PE12.4,$)') A(MT(i,j))
        if(j.eq.dim) write(*,*)
      ENDDO
      ENDDO
    
    
      id=rDiagonal2(A(MT(1,1)),A(MT(1,2)),A(MT(2,2)))
      
      write(*,*) "Eigenvalues:",  MassArray(id,1), MassArray(id,2)

      write(*,*) "rotation :"
      DO i=1,dim
      DO j=1,dim
        write(*,fmt='(3x, 1PE12.4,$)') MixMatrix(id,i,j)
        if(j.eq.dim) write(*,*)
      ENDDO
      ENDDO


      write(*,*) "restoring of original matrix:" 
      DO i=1,dim
      DO j=1,dim
        sr=0
        DO k=1,dim
         sr= sr+MixMatrix(id,k,i)*MassArray(id,k)*MixMatrix(id,k,j)
        ENDDO
        write(*,fmt='(3x, 1PE12.4,$)') sr
        if(j.eq.dim) write(*,*)
      ENDDO
      ENDDO

      write(*,*) 
      write(*,*)"Diagonalizing of general real  matrix:"
      write(*,*)"===================================================="
      A(MT(1,1))=0.1
      A(MT(1,2))=2 
      A(MT(2,1))=3
      A(MT(2,2))=2

      DO i=1,dim
      DO j=1,dim
        write(*,fmt='(3x, 1PE12.4,$)') A(MT(i,j))
        if(j.eq.dim) write(*,*)
      ENDDO
      ENDDO
        
      id=rDiagonalA2(A(MT(1,1)),A(MT(1,2)),
     >               A(MT(2,1)),A(MT(2,2)))
      write(*,*) "Eigenvalues :",MassArray(id,1), MassArray(id,2) 

      write(*,*) "V rotation"
      DO i=1,dim
      DO j=1,dim
        write(*,fmt='(3x, 1PE12.4,$)') MixMatrix(id,i,j)
        if(j.eq.dim) write(*,*)
      ENDDO
      ENDDO
      write(*,*) "U rotation"
      DO i=1,dim
      DO j=1,dim
        write(*,fmt='(3x, 1PE12.4,$)') MixMatrixU(id,i,j)
        if(j.eq.dim) write(*,*)
      ENDDO
      ENDDO

      write(*,*) "restoring of original matrix:" 
      DO i=1,dim
      DO j=1,dim
        sr=0
        DO k=1,dim
         sr= sr+MixMatrixU(id,k,i)*MassArray(id,k)*MixMatrix(id,k,j)
        ENDDO
        write(*,fmt='(3x, 1PE12.4,$)') sr
        if(j.eq.dim) write(*,*)
      ENDDO
      ENDDO

      write(*,*) 
      write(*,*) "Diagonalizing of Hermitian  matrix:"
      write(*,*)"===================================================="
    
      Ac(MT(1,1))=0.1 
      Ac(MT(1,2))=COMPLEX(3,1.5)
      Ac(MT(2,1))=conjg(Ac(MT(1,2)))
      Ac(MT(2,2))=2

      DO i=1,dim
      DO j=1,dim
        call writeCMPLX(Ac(MT(i,j)))
        if(j.eq.dim) write(*,*) 
      ENDDO
      ENDDO
    
      id=cDiagonalH2(Ac(MT(1,1)),Ac(MT(1,2)),Ac(MT(2,2)))
    
      write(*,*) "Eigenvalues :", MassArray(id,1), MassArray(id,2)
      write(*,*) "rotation "
      DO i=1,dim
      DO j=1,dim
        call writeCMPLX(cMixMatrix(id,i,j))
        if(j.eq.dim) write(*,*) 
      ENDDO
      ENDDO 

      write(*,*) "restoring of original matrix:" 
      DO i=1,dim
      DO j=1,dim
        sc=0
        DO k=1,dim
         sc= sc+conjg(cMixMatrix(id,k,i))*MassArray(id,k)
     >        *cMixMatrix(id,k,j)
        ENDDO
        call writeCMPLX(sc)
        if(j.eq.dim) write(*,*) 
      ENDDO
      ENDDO

      write(*,*) 
      write(*,*) "Diagonalizing of general complex matrix:"
      write(*,*) "===================================================="
    
      Ac(MT(1,1))=COMPLEX(0.1   ,2   )
      Ac(MT(1,2))=COMPLEX(3     ,1.5 )
      Ac(MT(2,1))=COMPLEX(3     ,0   )
      Ac(MT(2,2))=COMPLEX(2     ,3   )
      
      DO i=1,dim
      DO j=1,dim
        call writeCMPLX(Ac(MT(i,j)))
        if(j.eq.dim) write(*,*) 
      ENDDO
      ENDDO
    
      id=cDiagonalA2(Ac(MT(1,1)),Ac(MT(1,2)),
     >               Ac(MT(2,1)),Ac(MT(2,2)))
    
      write(*,*) "Eigenvalues :", MassArray(id,1), MassArray(id,2)
      write(*,*) "rotation  V"
      DO i=1,dim
      DO j=1,dim
        call writeCMPLX(cMixMatrix(id,i,j))
        if(j.eq.dim) write(*,*) 
      ENDDO
      ENDDO 
      write(*,*) "rotation  U"
      DO i=1,dim
      DO j=1,dim
        call writeCMPLX(cMixMatrixU(id,i,j))
        if(j.eq.dim) write(*,*) 
      ENDDO
      ENDDO 

      write(*,*) "restoring of original matrix:" 
      DO i=1,dim
      DO j=1,dim
        sc=0
        DO k=1,dim
         sc= sc+conjg(cMixMatrixU(id,k,i))*MassArray(id,k)
     >        *cMixMatrix(id,k,j)
        ENDDO
        call writeCMPLX(sc)
        if(j.eq.dim) write(*,*) 
      ENDDO
      ENDDO

      write(*,*) 
      write(*,*) "Diagonalizing of symmetry complex matrix:"
      write(*,*)"===================================================="
    
      Ac(MT(1,1))=COMPLEX(0.1,3) 
      Ac(MT(1,2))=COMPLEX(3,1.5)
      Ac(MT(2,1))=Ac(MT(1,2))
      Ac(MT(2,2))=COMPLEX(2,1)

      DO i=1,dim
      DO j=1,dim
        call writeCMPLX(Ac(MT(i,j)))
        if(j.eq.dim) write(*,*) 
      ENDDO
      ENDDO
    
      id=cDiagonalS2(Ac(MT(1,1)),Ac(MT(1,2)),Ac(MT(2,2)))
    
      write(*,*) "Eigenvalues :", MassArray(id,1), MassArray(id,2)
      write(*,*) "rotation "
      DO i=1,dim
      DO j=1,dim
        call writeCMPLX(cMixMatrix(id,i,j))
        if(j.eq.dim) write(*,*) 
      ENDDO
      ENDDO 

      write(*,*) "restoring of original matrix:" 
      DO i=1,dim
      DO j=1,dim
        sc=0
        DO k=1,dim
         sc= sc+cMixMatrix(id,k,i)*MassArray(id,k)*cMixMatrix(id,k,j)
        ENDDO
        call writeCMPLX(sc)
        if(j.eq.dim) write(*,*) 
      ENDDO
      ENDDO

      END

      subroutine writeCmplx(X)
        COMPLEX*16 X
        real*8 re,im
        re=dreal(X)
        im=dimag(X)
        if(im<0) then 
           write(*,fmt='(3x,1PE11.4,A4,E10.4,$)') re,"-i*",-im
        else  
           write(*,fmt='(3x,1PE11.4,A4,E10.4,$)') re,"+i*", im
        endif
      end
