#include"../SLHAplus.h"

#define       MT(i,j)  (i-1)*dim+(j-1)
#define      sMT(i,j) (i-1)*dim-(i*(i-1))/2 +(j-1)
            

#define MAXDIM 4

int main(void)
{ int i,j,k,dim;
  double A[MAXDIM*MAXDIM];
  Complex Ac[MAXDIM*MAXDIM];
  int id;
  
  printf(" Testing dim=2 case\n");
  dim=2;  
  initDiagonal();  

  printf("\nDiagonalizing of real symmetry matrix:\n"
"==========================================================\n");

  A[MT(1,1)]=0.1;
  A[MT(1,2)]=A[MT(2,1)]=3;
  A[MT(2,2)]=2;
  
  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++)  
  {   printf(" %12.4E",A[MT(i,j)]);
      if(j==1)printf("  "); else printf("\n");
  }


  id=rDiagonal(dim,A[MT(1,1)],A[MT(1,2)],A[MT(2,2)]);
  
  printf("Eigenvalues : %E %E\n",   MassArray(id,1), MassArray(id,2) );
  printf("rotation :\n %12.4E  %12.4E\n %12.4E  %12.4E\n", MixMatrix(id,1,1), MixMatrix(id,1,2),
                                                 MixMatrix(id,2,1), MixMatrix(id,2,2));
                                                 
  printf("restoring of original matrix:\n"); 
 
  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++) 
  {  double s=0;
     for(k=1;k<=2;k++) s+=MixMatrix(id,k,i)*MassArray(id,k)*MixMatrix(id,k,j);
     printf(" %12.4E",s); if(j==1)printf("  "); else printf("\n");
  }

  printf("\nDiagonalizing of general real  matrix:\n"
"==========================================================\n");
  A[MT(1,1)]=0.1;
  A[MT(1,2)]=2; 
  A[MT(2,1)]=3;
  A[MT(2,2)]=2;


  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++)  
  {   printf(" %12.4E",A[MT(i,j)]);
      if(j==1)printf("  "); else printf("\n");
  }


  id=rDiagonalA(dim,A[MT(1,1)],A[MT(1,2)],A[MT(2,1)],A[MT(2,2)]);
  
  printf("Eigenvalues : %E %E\n",   MassArray(id,1), MassArray(id,2) );
  printf("V rotation :\n %12.4E  %12.4E\n %12.4E  %12.4E\n", MixMatrix(id,1,1), MixMatrix(id,1,2),
                                                             MixMatrix(id,2,1), MixMatrix(id,2,2));
  printf("U rotation :\n %12.4E  %12.4E\n %12.4E  %12.4E\n", MixMatrixU(id,1,1), MixMatrixU(id,1,2),
                                                             MixMatrixU(id,2,1), MixMatrixU(id,2,2));
                                                 
  printf("restoring of original matrix:\n"); 
 
  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++) 
  {  double s=0;
     for(k=1;k<=dim;k++) s+=MixMatrixU(id,k,i)*MassArray(id,k)*MixMatrix(id,k,j);
     printf(" %12.4E",s); if(j==1)printf("  "); else printf("\n");
  }

  printf("\nDiagonalizing of Hermitian  matrix:\n"
"==========================================================\n");

  Ac[MT(1,1)]=0.1  ;
  Ac[MT(1,2)]=3   +I*1.5;
  Ac[MT(2,1)]=conj(Ac[MT(1,2)]);
  Ac[MT(2,2)]=2    ;
  
  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++)
  { double re=creal(Ac[MT(i,j)]), im=cimag(Ac[MT(i,j)]);
    if(im<0)   printf(" %11.4E -i*(%10.4E)",re,-im);
    else       printf(" %11.4E +i*(%10.4E)",re, im);
    if(j==1)printf("  "); else printf("\n");
  }  


  id=cDiagonalH(dim,Ac[MT(1,1)],Ac[MT(1,2)],Ac[MT(2,2)]);

  printf("Eigenvalues : %E %E\n",   MassArray(id,1), MassArray(id,2) );
  printf("rotation :\n");
  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++)
  { double re=creal(cMixMatrix(id,i,j)), im=cimag(cMixMatrix(id,i,j));
    if(im<0)   printf(" %11.4E -i*(%10.4E)",re,-im);
    else       printf(" %11.4E +i*(%10.4E)",re, im);
    if(j==1)printf("  "); else printf("\n");
  }  

  printf("restoring of original matrix:\n"); 
 
  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++) 
  {  Complex s=0;
     for(k=1;k<=dim;k++) s+=conj(cMixMatrix(id,k,i))*MassArray(id,k)*cMixMatrix(id,k,j);
     { double re=creal(s), im=cimag(s);
       if(im<0)   printf(" %11.4E -i*(%10.4E)",re,-im);
       else       printf(" %11.4E +i*(%10.4E)",re, im);
     }     
     if(j==1)printf("  "); else printf("\n");
  }




  printf("\nDiagonalizing of general complex matrix:\n"
"==========================================================\n");

  Ac[MT(1,1)]=0.1 +I*2  ;
  Ac[MT(1,2)]=3   +I*1.5;
  Ac[MT(2,1)]=3         ;
  Ac[MT(2,2)]=2+  I*3   ;
  
  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++)
  { double re=creal(Ac[MT(i,j)]), im=cimag(Ac[MT(i,j)]);
    if(im<0)   printf(" %11.4E -i*(%10.4E)",re,-im);
    else       printf(" %11.4E +i*(%10.4E)",re, im);
    if(j==1)printf("  "); else printf("\n");
  }  


  id=cDiagonalA(dim,Ac[MT(1,1)],Ac[MT(1,2)],Ac[MT(2,1)],Ac[MT(2,2)]);

  printf("Eigenvalues : %E %E\n",   MassArray(id,1), MassArray(id,2) );
  printf("rotation V:\n");
  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++)
  { double re=creal(cMixMatrix(id,i,j)), im=cimag(cMixMatrix(id,i,j));
    if(im<0)   printf(" %11.4E -i*(%10.4E)",re,-im);
    else       printf(" %11.4E +i*(%10.4E)",re, im);
    if(j==1)printf("  "); else printf("\n");
  }  
  printf("rotation U:\n");

  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++)
  { double re=creal(cMixMatrixU(id,i,j)), im=cimag(cMixMatrixU(id,i,j));
    if(im<0)   printf(" %11.4E -i*(%10.4E)",re,-im);
    else       printf(" %11.4E +i*(%10.4E)",re, im);
    if(j==1)printf("  "); else printf("\n");
  }  

                                                 
  printf("restoring of original matrix:\n"); 
 
  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++) 
  {  Complex s=0;
     for(k=1;k<=dim;k++) s+=conj(cMixMatrixU(id,k,i))*MassArray(id,k)*cMixMatrix(id,k,j);
     { double re=creal(s), im=cimag(s);
       if(im<0)   printf(" %11.4E -i*(%10.4E)",re,-im);
       else       printf(" %11.4E +i*(%10.4E)",re, im);
     }     
     if(j==1)printf("  "); else printf("\n");
  }



  printf("\nDiagonalizing of complex symmetry matrix:\n"
"==========================================================\n");

  Ac[MT(1,1)]=0.1 +I*2  ;
  Ac[MT(1,2)]=3   +I*1.5;
  Ac[MT(2,1)]=Ac[MT(1,2)];
  Ac[MT(2,2)]=2+  I*3   ;
  

  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++)
  { double re=creal(Ac[MT(i,j)]), im=cimag(Ac[MT(i,j)]);
    if(im<0)   printf(" %11.4E -i*(%10.4E)",re,-im);
    else       printf(" %11.4E +i*(%10.4E)",re, im);
    if(j==1)printf("  "); else printf("\n");
  }  


  id=cDiagonalS(dim,Ac[MT(1,1)],Ac[MT(1,2)],Ac[MT(2,2)]);

  printf("Eigenvalues : %E %E\n",   MassArray(id,1), MassArray(id,2) );
  printf("rotation V:\n");
  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++)
  { double re=creal(cMixMatrix(id,i,j)), im=cimag(cMixMatrix(id,i,j));
    if(im<0)   printf(" %11.4E -i*(%10.4E)",re,-im);
    else       printf(" %11.4E +i*(%10.4E)",re, im);
    if(j==1)printf("  "); else printf("\n");
  }  
                                                 
  printf("restoring of original matrix:\n"); 
 
  for(i=1;i<=dim;i++) for(j=1;j<=dim;j++) 
  {  Complex s=0;
     for(k=1;k<=dim;k++) s+=cMixMatrix(id,k,i)*MassArray(id,k)*cMixMatrix(id,k,j);
     { double re=creal(s), im=cimag(s);
       if(im<0)   printf(" %11.4E -i*(%10.4E)",re,-im);
       else       printf(" %11.4E +i*(%10.4E)",re, im);
     }     
     if(j==1)printf("  "); else printf("\n");
  }

}
