      IMPLICIT NONE  

#include"../SLHAplus.fh"

#define DIM 4
#define nTest 20

      INTEGER N,i,j,k,err
      REAL*8  Ar(DIM*DIM),Vr(DIM*DIM),Ur(DIM*DIM),m(DIM),diff,sumR 
      COMPLEX*16 Ac(DIM*DIM),Vc(DIM*DIM),Uc(DIM*DIM),sumC
      INTEGER MT,sMT

      MT(i,j)=  (i-1)*DIM+j
      sMT(i,j)= (i-1)*DIM-(i*(i-1))/2 +j

    
      write(*,*)"Testing Jacobi diagonalisation for random matrices:"
      write(*,*)"Dimension= ", DIM,  "  Number of calls= ",nTest
    
      write(*,*) " Testing rJacobi"
      DO N=1,nTest  
        DO i=1,(DIM*(DIM+1))/2
          Ar(i)=rand(0)
        ENDDO
        err=rJacobi(Ar,DIM,m, Vr)
        diff=0
        DO i=1, DIM
          DO j=i, DIM
            sumR=0
            DO K=1,DIM 
               sumR=sumR+ Vr(MT(k,i))*m(k)*Vr(MT(k,j))
            ENDDO  
            sumR=sumR-Ar(sMT(i,j))
            diff=diff+sumR*sumR 
          ENDDO
        ENDDO 
        
        write(*,fmt='("diff= ",1PE8.2, "  EV= ",$)') sqrt(diff)
        DO k=1,DIM 
          write(*,fmt='(1PE12.5,$)')  m(k)
        ENDDO
        write(*,*)    
      ENDDO

    
      write(*,*) " Testing rJacobiA"
      DO N=1,nTest  
        DO i=1,DIM*DIM
          Ar(i)=rand(0)
        ENDDO
        err=rJacobiA(Ar,DIM,m,Ur, Vr)
        diff=0
        DO i=1, DIM
          DO j=1, DIM
            sumR=0
            DO K=1,DIM 
               sumR=sumR+ Ur(MT(k,i))*m(k)*Vr(MT(k,j))
            ENDDO  
            sumR=sumR-Ar(MT(i,j))
            diff=diff+sumR*sumR 
          ENDDO
        ENDDO 
        
        write(*,fmt='("diff= ",1PE8.2, "  EV= ",$)') sqrt(diff)
        DO k=1,DIM 
          write(*,fmt='(1PE12.5,$)')  m(k)
        ENDDO
        write(*,*)    
      ENDDO

      write(*,*) " Testing cJacobiA"
      DO N=1,nTest  
        DO i=1,DIM*DIM
          Ac(i)=COMPLEX(rand(0),rand(0))
        ENDDO
        err=cJacobiA(Ac,DIM,m,Uc, Vc)
        diff=0
        DO i=1, DIM
          DO j=1, DIM
            sumC=0
            DO K=1,DIM 
               sumC=sumC+ CONJG(Uc(MT(k,i)))*m(k)*Vc(MT(k,j))
            ENDDO  
            sumC=sumC-Ac(MT(i,j))
            diff=diff+sumC*CONJG(sumC) 
          ENDDO
        ENDDO 
        
        write(*,fmt='("diff= ",1PE8.2, "  EV= ",$)') sqrt(diff)
        DO k=1,DIM 
          write(*,fmt='(1PE12.5,$)')  m(k)
        ENDDO
        write(*,*)    
      ENDDO

      write(*,*) " Testing cJacobiH"
      DO N=1,nTest  
        DO i=1,DIM
        DO j=i+1,DIM 
          Ac(sMT(i,j))=COMPLEX(rand(0),rand(0))
        ENDDO
          Ac(sMT(i,i))=COMPLEX(rand(0),0)
        ENDDO  
        err=cJacobiH(Ac,DIM,m,Vc)
        diff=0
        DO i=1, DIM
          DO j=i, DIM
            sumC=0
            DO K=1,DIM 
               sumC=sumC+ CONJG(Vc(MT(k,i)))*m(k)*Vc(MT(k,j))
            ENDDO 
            sumC=sumC-Ac(sMT(i,j))
            diff=diff+sumC*CONJG(sumC) 
          ENDDO
        ENDDO 
        
        write(*,fmt='("diff= ",1PE8.2, "  EV= ",$)') sqrt(diff)
        DO k=1,DIM 
          write(*,fmt='(1PE12.5,$)')  m(k)
        ENDDO
        write(*,*)    
      ENDDO


      write(*,*) " Testing cJacobiS"
      DO N=1,nTest  
        DO i=1,(DIM*(DIM+1))/2
          Ac(i)=COMPLEX(rand(0),rand(0))
        ENDDO
        err=cJacobiS(Ac,DIM,m, Vc)
        diff=0
        DO i=1, DIM
          DO j=i, DIM
            sumC=0
            DO K=1,DIM 
               sumC=sumC+ Vc(MT(k,i))*m(k)*Vc(MT(k,j))
            ENDDO  
            sumC=sumC-Ac(sMT(i,j))
            diff=diff+sumC*CONJG(sumC) 
          ENDDO
        ENDDO 
        
        write(*,fmt='("diff= ",1PE8.2, "  EV= ",$)') sqrt(diff)
        DO k=1,DIM 
          write(*,fmt='(1PE12.5,$)')  m(k)
        ENDDO
        write(*,*)    
      ENDDO


      END