#include"../SLHAplus.h"

#define  MT(i,j) ((i)*DIM+(j))
#define sMT(i,j) ((i)*DIM-((i)*((i)+1))/2 +(j))

#define DIM 4
#define nTest 20

/*
#define creal real
#define cimag imag
#define carg  arg
#define clog  log
#define cexp  exp
#define cpow  pow
*/

//const Complex I=Complex(0,1);


int main(void)
{  
  int N,i,j,k;
  double  Ar[DIM*DIM],Vr[DIM*DIM],Ur[DIM*DIM],m[DIM],diff; 
  Complex Ac[DIM*DIM],Vc[DIM*DIM],Uc[DIM*DIM];

  printf("\nTesting Jacobi diagonalisation for random matrices:  Dimension=%d, Number of calls=%d\n",DIM,nTest);

  printf("\nTesting rJacobi\n");    
  for(N=0;N<nTest;N++)
  {  
    for(i=0;i<(DIM*(DIM+1))/2;i++) Ar[i]=drand48();
    
    rJacobi(Ar,DIM,m, Vr);
    
    for(diff=0, i=0;i<DIM;i++) for(j=i;j<DIM;j++)
    { double sum=0;
      for(k=0;k<DIM;k++) sum+=Vr[MT(k,i)]*m[k]*Vr[MT(k,j)]; 
      sum=sum-Ar[sMT(i,j)];
      diff=diff+sum*sum;
    }

    printf("diff=%.2E  EV: ",sqrt(diff)); 
    for(i=0;i<DIM;i++) printf("%14.5E",m[i]);
    printf("\n");    
  }

  printf("\nTesting rJacobiA\n");    
  for(N=0;N<nTest;N++)
  {  
    for(i=0;i<DIM*DIM;i++) Ar[i]=drand48();

    rJacobiA(Ar,DIM,m,Ur, Vr);
    
    for(diff=0,i=0;i<DIM;i++) for(j=0;j<DIM;j++)
    { double sum=0;
      for(k=0;k<DIM;k++) sum+=Ur[MT(k,i)]*m[k]*Vr[MT(k,j)];
      sum=sum-Ar[MT(i,j)];
      diff=diff+sum*sum;
    }
    printf("diff=%.2E  EV: ",sqrt(diff));
    for(i=0;i<DIM;i++) printf("%14.5E",m[i]);
    printf("\n");                  
  }

  printf("\nTesting cJacobiA\n");    
  for(N=0;N<nTest;N++)
  { 
    for(i=0;i<DIM;i++) for(j=0;j<DIM;j++) Ac[i*DIM+j]=Complex(drand48(),drand48());

    cJacobiA(Ac,DIM,m,Uc, Vc);
    
    for(diff=0,i=0;i<DIM;i++) for(j=0;j<DIM;j++)
    { Complex sum=0;
      for(sum=0,k=0;k<DIM;k++) sum+=conj(Uc[MT(k,i)])*m[k]*Vc[MT(k,j)];
      sum=sum-Ac[MT(i,j)];
      diff=diff+real(sum*conj(sum));
    }
    printf("diff=%.2E EV: ",sqrt(diff));
    for(i=0;i<DIM;i++) printf("%14.5E",m[i]);
    printf("\n");                  
  }

  printf("\nTesting cJacobiH\n");    
  for(N=0;N<nTest;N++)
  { 
    for(i=0;i<DIM-1;i++) for(j=i+1;j<DIM;j++) 
               Ac[sMT(i,j)]=Complex(drand48(),drand48());
    for(i=0;i<DIM  ;i++) Ac[sMT(i,i)]=drand48();
    
    cJacobiH(Ac,DIM, m, Vc);

    for(diff=0,i=0;i<DIM;i++) for(j=i;j<DIM;j++)
    { Complex sum=0;
      for(sum=0,k=0;k<DIM;k++) sum+=conj(Vc[MT(k,i)])*m[k]*Vc[MT(k,j)];
      sum=sum-Ac[sMT(i,j)];
      diff=diff+real(sum*conj(sum));
    }
    printf("diff=%.2E EV: ",sqrt(diff)); 
    for(i=0;i<DIM;i++) printf("%14.5E",m[i]);
    printf("\n");                  
  }  
  
  printf("\nTesting cJacobiS\n");    
  for(N=0;N<nTest;N++)
  { 
    for(i=0;i<(DIM*(DIM+1))/2 ;i++) Ac[i]=Complex(drand48(),drand48());    

    cJacobiS(Ac,DIM,m,Vc);

    for(diff=0,i=0;i<DIM;i++) for(j=i;j<DIM;j++)
    { Complex sum=0;
      for(k=0;k<DIM;k++) sum+=Vc[MT(k,i)]*m[k]*Vc[MT(k,j)];
      sum=sum-Ac[sMT(i,j)];
      diff+=real(sum*conj(sum));
    }
    printf("diff=%.2E EV: ",sqrt(diff));
    for(i=0;i<DIM;i++) printf("%14.5E",m[i]);
    printf("\n");                  
  }

}
