      IMPLICIT NONE
#include"../SLHAplus.fh"
      integer nv,err,i,j,nChannel,prtcls(10),eQ3,spinDim,cDim,anti
      real*8 Br


C! Reading SLHA file 
       write(6,*) 'Reading of input file "spectr.slha"'

C       err=slhaRead('spectr.slha',0)
       open(20,FILE='spectr.slha',STATUS='OLD',ERR=111)  
       err=slhaReadStream(20,0,'</slha>')
       close(20) 
       write(6,*) '              error code is ' ,err
       if(err.ne.0) stop

C! Checking warnings    
       write(*,*) 'SLHA Warnings:'
       nv = slhaWarnings(0)  
       if(nv.ne.0 ) then 
          write(*,*) 'There are ', nv,  'warnings'
          nv=slhaWarnings(6)
       else   
          write(*,*)'     no  Warnings' 
       endif


C! Masses 

       write(*,*) 'Particle masses'
       write(*,fmt='("     lightest neutralino:", 1PE10.3)') 
     >  slhaVal1('Mass',0.d0,1000022 )
        write(*,fmt='("    first  neutral Higgs     :",1PE10.3)')
     >  slhaVal1('Mass',0.d0,25) 

        write(*,fmt='("    second neutral Higgs     :",1PE10.3)')
     >  slhaVal1('Mass',0.d0,35) 
   
C!Mixing matrix 
       write(*,*) 
       write(*,fmt='("Stau mixing matrix element Zl22 : ",1PE10.3)')
     > slhaVal2('STAuMIX',0.d0,2,2)
       write(*,*) 'ferror=',ferror
C! Running strong coupling:
       write(*,*)'Running strong coupling  g3=sqrt(4*pi*alphaS):'
       if(slhaValExists1('GaUge',3).ne.0 ) then 
         write(*,fmt='("        at 100 GeV = ", 1PE10.3)')
     >  slhaVal1('GAUGE', 100.d0, 3)
         write(*,fmt='("        at 10^6 GeV = ",1PE10.3)')
     >  slhaVal1('GAUGE', 1D6, 3)
       else 
         write(*,*) 'No  data'
       endif  
C! Reading  decays information
       write(*,*) 'Reading  decays' 
       err=slhaRead('decay.slha',1)
   
       write(*,*) ' Decays of second neutral Higgs'
       nChannel=slhaDecayExists(35)
       write(*,fmt='(5x, I3," - channels of decay for neutral Higgs")')
     > nChannel
       if(nChannel.gt.0) then 
        write(*,fmt='("   H width= ", 1PE10.3)') slhaWidth(35) 
        write(*,*) '   Fist 5 decay channels'
        DO i=1, min(nChannel,5)
         Br=slhaBranch(35,i,prtcls)
         write(*,fmt='(" 35  -> ",$)') 
         DO j=1, 10
           if((prtcls(j).eq.0)  ) goto 11
           write(*,fmt='(1x,I10,1x,$)') prtcls(j)
         endDO 
11       write(*,fmt='("  Branching= ",1PE10.3)') Br
        endDO
       else
         write(*,*) '  no decay information'   
       endif

 
      write(*,*) 'Particle N=144 quantum numbers:'
      if(findQnumbers(144,eQ3,spinDim,cDim,anti).NE.0) then 
        write(*,*) '3*el.charge=',eQ3,' spinDim=',spinDim,
     >  ' colorDim=',cDim,' has_antiparticle=',anti
      else 
        write(*,*) 'No QNUMBER for PDG=144'
      endif

C! Writing summary SLHA file:   
      write(*,*) 'Writing summary copy of input files to "copy.slha"' 
      err=slhaWrite('copy.slha')
      return 
111   write(*,*) 'can not open file'

      end

